VTK: vtkRenderbuffer Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkRenderbuffer Class Reference

Storage for FBO's. More...

`#include <vtkRenderbuffer.h>`

Inheritance diagram for vtkRenderbuffer:
[legend]
Collaboration diagram for vtkRenderbuffer:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkRenderbuffer * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | CreateColorAttachment (unsigned int width, unsigned int height)
| Sets up an RGBAF renderbufffer for use as a color attachment. More...
int | CreateDepthAttachment (unsigned int width, unsigned int height)
| Sets up an DEPTH renderbufffer for use as a color attachment. More...
int | Create (unsigned int format, unsigned int width, unsigned int height)
| Sets up an renderbufffer. More...
int | Create (unsigned int format, unsigned int width, unsigned int height, unsigned int samples)
void | ReleaseGraphicsResources (vtkWindow *win)
void | Resize (unsigned int width, unsigned int height)
virtual unsigned int | GetHandle ()
| Get the name of the buffer for use opengl code. More...
void | SetContext (vtkRenderWindow *win)
| Setting the context has the side affect of initializing OpenGL required extensions and allocates an OpenGL name(handle) that is released when the object is destroyed. More...
vtkRenderWindow * | GetContext ()
| Setting the context has the side affect of initializing OpenGL required extensions and allocates an OpenGL name(handle) that is released when the object is destroyed. More...
virtual unsigned int | GetWidth ()
| Get the buffer dimensions. More...
virtual unsigned int | GetHeight ()
| Get the buffer dimensions. More...
virtual unsigned int | GetSamples ()
| Get the buffer dimensions. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkRenderbuffer * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkRenderbuffer * | SafeDownCast (vtkObjectBase *o)
static bool | IsSupported (vtkRenderWindow *renWin)
| Returns if the context supports the required extensions. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkRenderbuffer ()
| ~vtkRenderbuffer () override
bool | LoadRequiredExtensions (vtkRenderWindow *renWin)
void | Alloc ()
void | Free ()
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | DepthBufferFloat
unsigned int | Width
unsigned int | Height
unsigned int | Format
unsigned int | Samples
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Storage for FBO's.

Lightweight API to OpenGL Framebuffer Object EXT renderbuffers.

Definition at line 21 of file vtkRenderbuffer.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkRenderbuffer::Superclass

Definition at line 25 of file vtkRenderbuffer.h.

## Constructor & Destructor Documentation

## ◆ vtkRenderbuffer()

vtkRenderbuffer::vtkRenderbuffer | ( |  | ) |
| protected

## ◆ ~vtkRenderbuffer()

vtkRenderbuffer::~vtkRenderbuffer | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkRenderbuffer* vtkRenderbuffer::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkRenderbuffer::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkRenderbuffer::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkRenderbuffer* vtkRenderbuffer::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkRenderbuffer::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkRenderbuffer* vtkRenderbuffer::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkRenderbuffer::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ IsSupported()

static bool vtkRenderbuffer::IsSupported | ( | vtkRenderWindow * | renWin | ) |
| static

Returns if the context supports the required extensions.

Extension will be loaded when the context is set.

## ◆ GetHandle()

virtual unsigned int vtkRenderbuffer::GetHandle | ( |  | ) |
| virtual

Get the name of the buffer for use opengl code.

## ◆ SetContext()

void vtkRenderbuffer::SetContext | ( | vtkRenderWindow * | win | ) |

Setting the context has the side affect of initializing OpenGL required extensions and allocates an OpenGL name(handle) that is released when the object is destroyed.

NOTE: the reference count to the passed in object is not incremented. Context must be set prior to other use.

## ◆ GetContext()

vtkRenderWindow* vtkRenderbuffer::GetContext | ( |  | ) |

Setting the context has the side affect of initializing OpenGL required extensions and allocates an OpenGL name(handle) that is released when the object is destroyed.

NOTE: the reference count to the passed in object is not incremented. Context must be set prior to other use.

## ◆ CreateColorAttachment()

int vtkRenderbuffer::CreateColorAttachment | ( | unsigned int | width,
|  | unsigned int | height
| ) |  |

Sets up an RGBAF renderbufffer for use as a color attachment.

Use mode to control READ or DRAW operation.

## ◆ CreateDepthAttachment()

int vtkRenderbuffer::CreateDepthAttachment | ( | unsigned int | width,
|  | unsigned int | height
| ) |  |

Sets up an DEPTH renderbufffer for use as a color attachment.

Use mode to control READ or DRAW operation.

## ◆ Create() [1/2]

int vtkRenderbuffer::Create | ( | unsigned int | format,
|  | unsigned int | width,
|  | unsigned int | height
| ) |  |

Sets up an renderbufffer.

Use mode to control READ or DRAW operation and format to control the internal format. (see OpenGL doc for more info)

## ◆ Create() [2/2]

int vtkRenderbuffer::Create | ( | unsigned int | format,
|  | unsigned int | width,
|  | unsigned int | height,
|  | unsigned int | samples
| ) |  |

## ◆ ReleaseGraphicsResources()

void vtkRenderbuffer::ReleaseGraphicsResources | ( | vtkWindow * | win | ) |

## ◆ Resize()

void vtkRenderbuffer::Resize | ( | unsigned int | width,
|  | unsigned int | height
| ) |  |

## ◆ GetWidth()

virtual unsigned int vtkRenderbuffer::GetWidth | ( |  | ) |
| virtual

Get the buffer dimensions.

These are the properties of the OpenGL renderbuffer this instance represents.

## ◆ GetHeight()

virtual unsigned int vtkRenderbuffer::GetHeight | ( |  | ) |
| virtual

Get the buffer dimensions.

These are the properties of the OpenGL renderbuffer this instance represents.

## ◆ GetSamples()

virtual unsigned int vtkRenderbuffer::GetSamples | ( |  | ) |
| virtual

Get the buffer dimensions.

These are the properties of the OpenGL renderbuffer this instance represents.

## ◆ LoadRequiredExtensions()

bool vtkRenderbuffer::LoadRequiredExtensions | ( | vtkRenderWindow * | renWin | ) |
| protected

## ◆ Alloc()

void vtkRenderbuffer::Alloc | ( |  | ) |
| protected

## ◆ Free()

void vtkRenderbuffer::Free | ( |  | ) |
| protected

## Member Data Documentation

## ◆ DepthBufferFloat

int vtkRenderbuffer::DepthBufferFloat
| protected

Definition at line 95 of file vtkRenderbuffer.h.

## ◆ Width

unsigned int vtkRenderbuffer::Width
| protected

Definition at line 97 of file vtkRenderbuffer.h.

## ◆ Height

unsigned int vtkRenderbuffer::Height
| protected

Definition at line 98 of file vtkRenderbuffer.h.

## ◆ Format

unsigned int vtkRenderbuffer::Format
| protected

Definition at line 99 of file vtkRenderbuffer.h.

## ◆ Samples

unsigned int vtkRenderbuffer::Samples
| protected

Definition at line 100 of file vtkRenderbuffer.h.

The documentation for this class was generated from the following file:

- Rendering/OpenGL2/vtkRenderbuffer.h